#include <Xm/Xm.h>
#include <Xm/DialogS.h>
#include <Xm/SelectioB.h>
#include <Xm/MessageB.h>
#include <Xm/TextF.h>
#include <Xm/RowColumn.h>
#include <Xm/ToggleBG.h>
#include <Xm/PushB.h>
#include <Xm/LabelG.h>
#include <Xm/MainW.h>
#include <Xm/Text.h>
#include <stdlib.h>
#include <stdio.h>
#include <iostream.h>

#include "global.h"


/* ........   c a l l b a c k s   ................. */
extern void cancel_cb(Widget, XtPointer, XtPointer);

void ok_sr(Widget widget, XtPointer client_data, XtPointer call_data) {
  char *text, c[20];
  int  i;
  Widget tfield=(Widget)client_data;

  XtVaGetValues(tfield, XmNvalue, &text, NULL);
  if (atoi(text)>0) {
    reg.sr=atoi(text);
    reg.nbuf = reg.length*reg.sr/reg.xpix;
    if (reg.nbuf<1) {
      reg.nbuf=1;
      reg.length=reg.nbuf*reg.xpix/reg.sr;
    }
    sprintf(c,"%d", reg.length);
    XtVaSetValues(trace_label,
		  XtVaTypedArg, XmNlabelString, XmRString, c, strlen(c)+1,
		  NULL);
    sprintf(c,"%d", reg.sr);
    XtVaSetValues(sr_label,
		  XtVaTypedArg, XmNlabelString, XmRString, c, strlen(c)+1,
		  NULL);
    for(i=0; i<8; i++) ch[i].buf = (char *)realloc(ch[i].buf, reg.nbuf*2);
  }
  XtFree(text);
}

void ok_tl(Widget widget, XtPointer client_data, XtPointer call_data) {
  char *text, c[20];
  int  i;

  Widget tfield=(Widget)client_data;

  XtVaGetValues(tfield, XmNvalue, &text, NULL);
  if (atoi(text)>0) {
    reg.length=atoi(text);
    if (reg.recon) {
      reg.resize=1;
    }
    else {
      reg.nbuf = reg.length*reg.sr/reg.xpix;
      if (reg.nbuf<1) {
	reg.nbuf=1;
	reg.length=reg.nbuf*reg.xpix/reg.sr;
      }
      sprintf(c,"%d", reg.length);
      XtVaSetValues(trace_label,
		    XtVaTypedArg, XmNlabelString, XmRString, c, strlen(c)+1,
		    NULL);
      sprintf(c,"%d", reg.sr);
      XtVaSetValues(sr_label,
		    XtVaTypedArg, XmNlabelString, XmRString, c, strlen(c)+1,
		    NULL);
      for(i=0; i<8; i++) ch[i].buf = (char *)realloc(ch[i].buf, reg.nbuf*2);
    }
  }
  XtFree(text);
}

void ok_ac(Widget widget, XtPointer client_data, XtPointer call_data) {
  int  i;
  char c[20];

  void analog_manage_widgets();
  extern void clearscreen(Window window);
  for(i=0; i<8; i++) {
    if (ch[i].active || dch[i].nch>0) XtSetSensitive(mymenu.calibrate.channel[i],True);
    else XtSetSensitive(mymenu.calibrate.channel[i],False);
  }
  if ((reg.nactive+der.nactive) > 0) XtSetSensitive(mymenu.recording.s_recording, True);
  if (analog_w) {
    XtPopdown(analog_w);
    XtDestroyWidget(analog_w);
  }
  analog_manage_widgets();
  if (reg.analog && ((reg.nactive+der.nactive)>0) ) XtPopup(analog_w, XtGrabNone);
  clearscreen(XtWindow(drawing_a));
  XtDestroyWidget(widget);
}

void toggle_cb(Widget tb, XtPointer client_data, XtPointer call_data) {
  int i=(int) client_data;
  XmToggleButtonCallbackStruct *toggle_data = (XmToggleButtonCallbackStruct *) call_data;
  if (toggle_data->set) {
    ch[i].active=1;
    reg.nactive++;
  }
  else {
    ch[i].active=0;
    reg.nactive--;
  }
}

void polarity_cb(Widget menu_item, XtPointer client_data, XtPointer call_data) {
  int chn;
  XtVaGetValues(XtParent(menu_item), XmNuserData, &chn, NULL);
  ch[chn].polarity=(int)client_data;
}

void color_cb(Widget menu_item, XtPointer client_data, XtPointer call_data) {
  int chn;
  XtVaGetValues(XtParent(menu_item), XmNuserData, &chn, NULL);
  ch[chn].color=(int)client_data;
}

void height_cb(Widget menu_item, XtPointer client_data, XtPointer call_data) {
  int chn;
  XtVaGetValues(XtParent(menu_item), XmNuserData, &chn, NULL);
  ch[chn].height=(int)client_data;
}

/* .......  e n d   o f   c a l l b a c k s   .................. */

void o_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  int           item=(int) client_data;
  int           i=0, j, retval;
  char          text[100];
  Arg           args[5];
  Widget        dialog, mbox, tfield, toggle_box, pulld, w;

  void analog_manage_widgets();
  extern void showtime(int);
  extern void derived_cb(Widget widget, XtPointer client_data, XtPointer call_data);

  switch(item) {
  case 0:   // sampling rate;
    if (!reg.recon) {
      dialog=XtVaCreateWidget("prompt", xmDialogShellWidgetClass, XtParent(drawing_a),
			      XmNtitle, "Sampling Rate",
			      NULL);
      mbox=XtVaCreateWidget("mbox", xmMessageBoxWidgetClass, dialog,
			    XmNmessageString, XmStringCreateLocalized("Enter sampling rate (Hz):"),
			    NULL);
      XtUnmanageChild(XmMessageBoxGetChild(mbox, XmDIALOG_HELP_BUTTON));
      tfield=XtVaCreateWidget("tfield", xmTextFieldWidgetClass, mbox,
			      NULL);
      sprintf(text,"%d",reg.sr);
      XtVaSetValues(tfield, XmNvalue, text, NULL);
      XtAddCallback(mbox, XmNokCallback, ok_sr, tfield);
      XtAddCallback(mbox, XmNcancelCallback, cancel_cb, NULL);
      XtManageChild(tfield);
      XtManageChild(mbox);
      XtManageChild(dialog);
      XtPopup(dialog, XtGrabNone);
    }
    break;
  case 1:  // trace length;
    dialog=XtVaCreateWidget("prompt", xmDialogShellWidgetClass, XtParent(drawing_a),
			    XmNtitle, "Trace Length",
			    NULL);
    mbox=XtVaCreateWidget("mbox", xmMessageBoxWidgetClass, dialog,
			  XmNmessageString, XmStringCreateLocalized("Enter length of trace (sec):"),
			  NULL);
    XtUnmanageChild(XmMessageBoxGetChild(mbox, XmDIALOG_HELP_BUTTON));
    tfield=XtVaCreateWidget("tfield", xmTextFieldWidgetClass, mbox,
			    NULL);
    sprintf(text,"%d",reg.length);
    XtVaSetValues(tfield, XmNvalue, text, NULL);
    XtAddCallback(mbox, XmNokCallback, ok_tl, tfield);
    XtAddCallback(mbox, XmNcancelCallback, cancel_cb, NULL);
    XtManageChild(tfield);
    XtManageChild(mbox);
    XtManageChild(dialog);
    XtPopup(dialog, XtGrabNone);
    break;  
  case 2:   // channel setup;
    if (!reg.recon) {
      i=0;
      XtSetArg(args[i], XmNautoUnmanage, False);    i++;
      XtSetArg(args[i], XmNtitle, "Channel Setup"); i++;
      dialog=XmCreateMessageDialog(XtParent(widget), "chsetup", args, i);
      XtAddCallback(dialog, XmNokCallback, ok_ac, widget);
      XtUnmanageChild(XmMessageBoxGetChild(dialog, XmDIALOG_HELP_BUTTON));
      XtUnmanageChild(XmMessageBoxGetChild(dialog, XmDIALOG_CANCEL_BUTTON));
      // create rowcolumn widget;
      toggle_box=XtVaCreateWidget("togglebox",
				  xmRowColumnWidgetClass, dialog,
				  XmNpacking, XmPACK_COLUMN,
				  XmNnumColumns, 5,
				  NULL);
      // create and set toggles for active;
      for (i=0; i<8; i++) {
	sprintf(text,"channel %d", i+1);
	w=XtVaCreateManagedWidget(text, xmToggleButtonGadgetClass, toggle_box, NULL);
	XtAddCallback(w, XmNvalueChangedCallback, toggle_cb, (void *) i);
	if (ch[i].active) XmToggleButtonGadgetSetState(w,True,False);
      }
      // create and set toggles for polarity;

      // create and set toggles for polarity;
      for (i=0; i<8; i++) {
	XtManageChild(
	      XmVaCreateSimpleOptionMenu(
					 toggle_box, "polarity", XmStringCreateLocalized(""), ' ', ch[i].polarity, polarity_cb,
					 XmVaPUSHBUTTON, XmStringCreateLocalized("Unipolar"), ' ', NULL, NULL,
					 XmVaPUSHBUTTON, XmStringCreateLocalized("Bipolar"), ' ', NULL, NULL,
					 XmNuserData, i,
					 NULL)
	      );
	}
      // create and set toggles for color;
      for (i=0; i<8; i++) {
	XtManageChild(
		      XmVaCreateSimpleOptionMenu(
						 toggle_box, "color", XmStringCreateLocalized(""), ' ', ch[i].color, color_cb,
						 XmVaPUSHBUTTON, XmStringCreateLocalized(colors[0]), ' ', NULL, NULL,
						 XmVaPUSHBUTTON, XmStringCreateLocalized(colors[1]), ' ', NULL, NULL,
						 XmVaPUSHBUTTON, XmStringCreateLocalized(colors[2]), ' ', NULL, NULL,
						 XmVaPUSHBUTTON, XmStringCreateLocalized(colors[3]), ' ', NULL, NULL,
						 XmVaPUSHBUTTON, XmStringCreateLocalized(colors[4]), ' ', NULL, NULL,
						 XmVaPUSHBUTTON, XmStringCreateLocalized(colors[5]), ' ', NULL, NULL,
						 XmVaPUSHBUTTON, XmStringCreateLocalized(colors[6]), ' ', NULL, NULL,
						 XmVaPUSHBUTTON, XmStringCreateLocalized(colors[7]), ' ', NULL, NULL,
						 XmNuserData, i,
						 NULL)
		      );
      }
      // create and set toggles for height;
      for (i=0; i<8; i++) {
	XtManageChild(
		      XmVaCreateSimpleOptionMenu(
						 toggle_box, "height", XmStringCreateLocalized(""), ' ', ch[i].height, height_cb,
						 XmVaPUSHBUTTON, XmStringCreateLocalized("width=1"), ' ', NULL, NULL,
						 XmVaPUSHBUTTON, XmStringCreateLocalized("width=2"), ' ', NULL, NULL,
						 XmVaPUSHBUTTON, XmStringCreateLocalized("width=3"), ' ', NULL, NULL,
						 XmVaPUSHBUTTON, XmStringCreateLocalized("width=4"), ' ', NULL, NULL,
						 XmNuserData, i,
						 NULL)
		      );
      }
      // create buttons for derived channels;
      for (i=0; i<8; i++) {
	sprintf(text,"channel %d", i+1);
	w=XtVaCreateManagedWidget("derived", xmPushButtonWidgetClass, toggle_box,
				  XmNalignment, XmALIGNMENT_CENTER,
				  NULL);
	if (dch[i].nch>0) XtVaSetValues(w, XmNlabelString, XmStringCreateLocalized("derived *"), NULL);
	else XtVaSetValues(w, XmNlabelString, XmStringCreateLocalized("derived  "), NULL);
	XtAddCallback(w, XmNactivateCallback, derived_cb, (void *) i);
      }

      XtManageChild(toggle_box);
      XtManageChild(dialog);
      XtPopup(XtParent(dialog), XtGrabNone);
    }
    break;
  case 3:   // show analog values;
    if (reg.analog) {
      reg.analog=0;
      if (analog_w) {
	XtPopdown(analog_w);
      }
    }
    else {
      reg.analog=1;
      if (!analog_w) {
	/* manage Textwidgets for all defined channels */
	analog_manage_widgets();      
      }
      /* popup Analog Window */
      if ((reg.nactive+der.nactive) > 0) XtPopup(analog_w, XtGrabNone);
    }
    break;
  case 4:   // monitor mode;
    if (reg.store) {
      XtVaSetValues(comment_label, XmNeditable, False, NULL);
      if (reg.recon) {
	showtime(4); // show recording duration anyway;
	showtime(2); // stop timer;
      }
      reg.store=0;
    }
    else {
      reg.store=1;
      if (reg.recon) {
	showtime(3); // continue timer;
	XtVaSetValues(comment_label, XmNeditable, True, NULL);
	XtSetSensitive(mymenu.file.s_data,True);
	reg.needsave=1;
      }
    }
    break;
  }
}

/* function to manage all Analog Text Widgets */
void analog_manage_widgets() {
  Widget toplevel, analog_main_w, analog_rc_w;
  int i, j;

  /* create Popup Window and Widgets for all possible channels */
  toplevel=XtParent(drawing_a);
  while (!XtIsTopLevelShell(toplevel)) toplevel=XtParent(toplevel);
  analog_w=XtVaCreatePopupShell("analog",
				topLevelShellWidgetClass, toplevel,
				XtNtitle, "XmAD v"VERSION,
				NULL);
  analog_main_w =XtVaCreateManagedWidget("main_w",
					 xmMainWindowWidgetClass, analog_w,
					 NULL);
  analog_rc_w=XtVaCreateManagedWidget("rowcol",
				      xmRowColumnWidgetClass, analog_main_w,
				      NULL);
  for (i=0; i<8; i++) {
    if (ch[i].active) 
      ch[i].analog=XtVaCreateManagedWidget("textfield",
					   xmTextWidgetClass, analog_rc_w,
					   XmNeditable, False,
					   NULL);
    for (j=0; j<7; j++)
      if (dch[i].ch[j].active)
	dch[i].ch[j].analog=XtVaCreateManagedWidget("textfield",
						    xmTextWidgetClass, analog_rc_w,
						    XmNeditable, False,
						    NULL);
  } /* endfor */
}
